#pragma BEGINDUMP

#include "HMG_UNICODE.h"

#include <hbapi.h>
#include <Windows.h>
#include <ShellApi.h>
#include <ShlObj.h>

HB_FUNC( GETDRIVETYPE )
{
   hb_retni( GetDriveType( (LPCSTR) hb_parc( 1 ) ) ) ;
}

#ifndef __XHARBOUR__
   #define ISBYREF( n )          HB_ISBYREF( n )
   #define ISNIL( n )            HB_ISNIL( n )
#endif

HB_FUNC(GETVOLUMEINFORMATION)
{
   char *VolumeNameBuffer     = (char *) hb_xgrab( MAX_PATH ) ;
   DWORD VolumeSerialNumber                                   ;
   DWORD MaximumComponentLength                               ;
   DWORD FileSystemFlags                                      ;
   char *FileSystemNameBuffer = (char *) hb_xgrab( MAX_PATH ) ;
   BOOL bRet;

   bRet = GetVolumeInformation( ISNIL(1) ? NULL : (LPCTSTR) hb_parc(1) ,
                                (LPTSTR) VolumeNameBuffer              ,
                                MAX_PATH                               ,
                                &VolumeSerialNumber                    ,
                                &MaximumComponentLength                ,
                                &FileSystemFlags                       ,
                                (LPTSTR)FileSystemNameBuffer           ,
                                  MAX_PATH ) ;
   if ( bRet  )
   {
      if ( ISBYREF( 2 ) )  hb_storc ((char *) VolumeNameBuffer, 2 ) ;
      if ( ISBYREF( 3 ) )  hb_stornl( (LONG)  VolumeSerialNumber, 3 ) ;
      if ( ISBYREF( 4 ) )  hb_stornl( (LONG)  MaximumComponentLength, 4 ) ;
      if ( ISBYREF( 5 ) )  hb_stornl( (LONG)  FileSystemFlags, 5 );
      if ( ISBYREF( 6 ) )  hb_storc ((char *) FileSystemNameBuffer, 6 );
   }

   hb_retl(bRet);
   hb_xfree( VolumeNameBuffer );
   hb_xfree( FileSystemNameBuffer );
}

HB_FUNC ( SHELLFILEOPERATION )
{
   SHFILEOPSTRUCT sh;
   ZeroMemory (&sh, sizeof(SHFILEOPSTRUCT));

   sh.hwnd   = ( HWND ) HMG_parnl( 1 );
   sh.pFrom  = HMG_parc(2);
   sh.pTo    = HMG_parc(3);
   sh.wFunc  = HMG_parnl(4);
   sh.fFlags = HMG_parnl(5);
   sh.hNameMappings = 0;
   sh.lpszProgressTitle = NULL;

   hb_retnl( SHFileOperation (&sh) );
}


HB_FUNC( LISTBOXSETMULTITAB )
{
   PHB_ITEM wArray;
   int      nTabStops[ 10 ];
   int      l, i;
   DWORD    dwDlgBase = GetDialogBaseUnits();
   int      baseunitX = LOWORD( dwDlgBase );

   HWND hwnd = ( HWND ) HMG_parnl( 1 );

   wArray = hb_param( 2, HB_IT_ARRAY );

   l = ( int ) hb_parinfa( 2, 0 ) - 1;

   for( i = 0; i <= l; i++ )
      nTabStops[ i ] = MulDiv( hb_arrayGetNI( wArray, i + 1 ), 4, baseunitX );

   SendMessage( hwnd, LB_SETTABSTOPS, l, ( LPARAM ) &nTabStops );
}


HB_FUNC( HWNDCOMBO )
{
   COMBOBOXINFO cbi      ;
   ZeroMemory( &cbi, sizeof( COMBOBOXINFO ) );
   cbi.cbSize = sizeof(COMBOBOXINFO);

   GetComboBoxInfo( (HWND) HMG_parnl( 1 ), &cbi );

   hb_retnl( (LONG)cbi.hwndCombo ) ;
}

HB_FUNC( HWNDCOMBOEDIT )
{
   COMBOBOXINFO cbi      ;
   ZeroMemory( &cbi, sizeof( COMBOBOXINFO ) );
   cbi.cbSize = sizeof(COMBOBOXINFO);

   GetComboBoxInfo( (HWND) HMG_parnl( 1 ), &cbi );

   hb_retnl( (LONG)cbi.hwndItem ) ;
   //hb_retnl( (LONG)cbi.hwndList ) ;
}

HB_FUNC( HWNDCOMBOLIST )
{
   COMBOBOXINFO cbi      ;
   ZeroMemory( &cbi, sizeof( COMBOBOXINFO ) );
   cbi.cbSize = sizeof(COMBOBOXINFO);

   GetComboBoxInfo( (HWND) HMG_parnl( 1 ), &cbi );

   hb_retnl( (LONG)cbi.hwndList ) ;
}

HB_FUNC( HWNDCOMBOSEND )
{
   COMBOBOXINFO cbi      ;
   ZeroMemory( &cbi, sizeof( COMBOBOXINFO ) );
   cbi.cbSize = sizeof(COMBOBOXINFO);

//   GetComboBoxInfo( (HWND) HMG_parnl( 1 ), &cbi );
   SendMessage( (HWND) HMG_parnl( 1 ), CB_GETCOMBOBOXINFO, 0, (LPARAM)&cbi);

   hb_retnl( (LONG)cbi.hwndList ) ;
}

HB_FUNC( CHANGESTYLE )
{
   HWND     hWnd     = ( HWND ) HMG_parnl( 1 );
   LONG_PTR dwAdd    = ( LONG_PTR ) HMG_parnl( 2 );
   LONG_PTR dwRemove = ( LONG_PTR ) HMG_parnl( 3 );
   int      iStyle   = hb_parl( 4 ) ? GWL_EXSTYLE : GWL_STYLE;
   LONG_PTR dwStyle, dwNewStyle;

   dwStyle    = GetWindowLongPtr( hWnd, iStyle );
   dwNewStyle = ( dwStyle & ( ~dwRemove ) ) | dwAdd;

   hb_retnl( ( LONG_PTR ) SetWindowLongPtr( hWnd, iStyle, dwNewStyle ) );

   SetWindowPos( hWnd, NULL, 0, 0, 0, 0, SWP_FRAMECHANGED | SWP_NOMOVE | SWP_NOSIZE | SWP_NOZORDER );
}

#pragma ENDDUMP

